-
Notifications
You must be signed in to change notification settings - Fork 0
/
Copy path127.word-ladder.java
101 lines (96 loc) · 2.54 KB
/
127.word-ladder.java
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
/*
* [127] Word Ladder
*
* https://leetcode.com/problems/word-ladder/description/
*
* algorithms
* Medium (19.84%)
* Total Accepted: 151.4K
* Total Submissions: 763.1K
* Testcase Example: '"hit"\n"cog"\n["hot","dot","dog","lot","log","cog"]'
*
*
* Given two words (beginWord and endWord), and a dictionary's word list, find
* the length of shortest transformation sequence from beginWord to endWord,
* such that:
*
*
* Only one letter can be changed at a time.
* Each transformed word must exist in the word list. Note that beginWord is
* not a transformed word.
*
*
*
* For example,
*
*
* Given:
* beginWord = "hit"
* endWord = "cog"
* wordList = ["hot","dot","dog","lot","log","cog"]
*
*
* As one shortest transformation is "hit" -> "hot" -> "dot" -> "dog" -> "cog",
* return its length 5.
*
*
*
* Note:
*
* Return 0 if there is no such transformation sequence.
* All words have the same length.
* All words contain only lowercase alphabetic characters.
* You may assume no duplicates in the word list.
* You may assume beginWord and endWord are non-empty and are not the same.
*
*
*
*
* UPDATE (2017/1/20):
* The wordList parameter had been changed to a list of strings (instead of a
* set of strings). Please reload the code definition to get the latest
* changes.
*
*/
class Solution {
public int ladderLength(String beginWord, String endWord, List<String> wordList) {
Set<String> words = new HashSet<>();
for (String word : wordList) {
words.add(word);
}
int steps = 0;
Set<String> visited = new HashSet<>();
Queue<String> fromBegin = new LinkedList<>();
fromBegin.offer(beginWord);
visited.add(beginWord);
Queue<String> fromEnd = new LinkedList<>();
fromEnd.offer(endWord);
visited.add(endWord);
while (!fromBegin.isEmpty() && !fromEnd.isEmpty()) {
int size = fromBegin.size();
steps++;
for (int i = 0; i < size; i++) {
String word = fromBegin.poll();
if (fromEnd.contains(word)) {
return steps;
}
enqueueNeighbors(fromBegin, word, words, visited);
}
Queue<String> temp = fromBegin;
fromBegin = fromEnd;
fromEnd = temp;
}
return 0;
}
private void enqueueNeighbors(Queue<String> search, String word, Set<String> words, Set<String> visited) {
for (int i = 0; i < word.length(); i++) {
for (char c = 'a'; c <= 'z'; c++) {
String newWord = word.substring(0,i) + c + word.substring(i+1);
if (words.contains(newWord) && !visited.contains(newWord)) {
search.offer(newWord);
visited.add(newWord);
}
}
}
}
}